package com.pfc.app.nbff;

import java.util.ArrayList;
import java.util.List;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.Bitmap;
import android.graphics.Point;
import android.graphics.RectF;
import android.graphics.drawable.Drawable;
import android.util.Log;
import android.widget.Toast;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;



public class LugaresOverlay extends ItemizedOverlay {

	private ArrayList<OverlayItem> mOverlays;
	private Context mContext;
	private Bitmap mAmigo;
	private GeoPoint mGeoPunto;
	
	public LugaresOverlay(Drawable defaultMarker, Context ctxt) {
		
		super(boundCenterBottom(defaultMarker));
		
		mContext = ctxt;
		mOverlays = new ArrayList<OverlayItem>();
	}

	@Override
	protected OverlayItem createItem(int i) {
		
		if(size()>0 && i<size())
			return mOverlays.get(i);
		else
			return null;
	}

	@Override
	public int size() {
		
		return mOverlays.size();
	}
	
	public void añadeOverlay(OverlayItem overlay){
	
		mOverlays.add(overlay);
		populate();
	}

	public void borraTodo(){
		mOverlays.clear();
	}
	
	@Override
	public boolean onTap(GeoPoint point, final MapView mapa) {
		
		 final List<Overlay> overlays  = mapa.getOverlays();
		 boolean encontrado = false;
		 int index = 0;
		 //Creamos el punto pulsado y la zona a pulsar. Además le asignamos al punto pulsado
		 //la proyeccion del Geopunto que se pulso en la pantalla.
		 RectF zonaParaPulsar;
		 Point puntoPulsado = new Point();
		 mapa.getProjection().toPixels(point, puntoPulsado);
		 Point puntoDeOverlay = new Point();
		 Log.i("LogOnTap", "Entrando en el bucle...");
		 //mientras no encontremos el punto y haya puntos que comrpobar
		 while(!encontrado && index < overlays.size()){
			 //Definimos el tamaño del rectangulo de la chincheta.
			 zonaParaPulsar = new RectF();
			 Log.i("LogOnTap", "Dentro delbucle...");
			 zonaParaPulsar.set(-10,-10,13,0);
			 Log.i("LogOnTap", "Entrando en el try...");
			 try
			 {
				 //Recogemos uno de los overlays dentro del mapa.
				 final LugaresOverlay overlay = (LugaresOverlay) overlays.get(index);
				 Log.i("LogOnTap", "Dentro en el try 1...");
				 mapa.getProjection().toPixels(overlay.getGeoPunto(), puntoDeOverlay);
				 Log.i("LogOnTap", "Dentro en el try 2...");
				 //Definimos el offset del rectangulo dentro de la pantalla.
				 zonaParaPulsar.offset(puntoDeOverlay.x+1,puntoDeOverlay.y+1);
				 Log.i("LogOnTap", "Entrando en el if...");
				 //Si la zona pulsada contiene el punto
				 if(zonaParaPulsar.contains(puntoPulsado.x,puntoPulsado.y)) 
				 {
					 //Creamos el constructor del diálogo
					 AlertDialog.Builder constructor = new AlertDialog.Builder(mapa.getContext());
					 //Configuramos propiedades
					 constructor.setTitle("¿Que desea hacer?");
					 constructor.setCancelable(true);
					 Log.i("LogOnTap", "Construído diálogo...");
					//Si el usuario pulsa sobre enviar un mail
					 constructor.setPositiveButton(R.string.enviaCorreo, new DialogInterface.OnClickListener() {

							public void onClick(DialogInterface dialog, int which) {
							
								Toast.makeText(mapa.getContext(), R.string.enviaCorreo, Toast.LENGTH_SHORT).show();
								dialog.dismiss();
							}
					 });
					 
					 //Si el usuario pulsa sobre eliminar el amigo
					 constructor.setNegativeButton(R.string.borraUsuario, new DialogInterface.OnClickListener() {

							public void onClick(DialogInterface dialog, int which) {
								
								Toast.makeText(mapa.getContext(), R.string.borraUsuario, Toast.LENGTH_SHORT).show();
								dialog.dismiss();
							}
					 });
					 //Mostramos el diálogo
					 constructor.create().show();
					 encontrado=true;					 
					 return true;
				 }	
			 }
			 catch(Exception exc)
			 {
				 Log.i("OnTapError", "colegui esto ha petado" + exc);
			 }
			 index++;
		}
		return false;
	}
	public GeoPoint getGeoPunto(){
		
		return mGeoPunto;
	}
}
